#!/usr/usc/bin/perl

use strict;

my $chrfile = $ARGV[0];
open(IN1,$ARGV[1]);
open(IN2,$ARGV[2]);

open(OUT,">final_scr");

my $line;
my @data;
my %sample;
my %junction;
my @order;
my $i;
while($line = <IN1>)
{
  chomp($line);
  @data = split(/ /,$line);
  push(@{$sample{$data[1]}},$data[0]);
}
close(IN1);
while($line = <IN2>)
{
  chomp($line);
  @data = split(/ /,$line);
  $junction{$data[1]} = $data[0];
  print "$data[0] $data[1]\n";
}
close(IN2);

my $key;
print OUT "echo \"Generating Annotation files\"\n";
print OUT "echo \"perl exon_sort.pl $ARGV[3] exon_sort $chrfile\"\n";
print OUT "perl exon_sort.pl $ARGV[3] exon_sort $chrfile\n";
print OUT "echo \"perl nonoverlap_exon_sort.pl exon_sort nonoverlap_exon_sort $chrfile\"\n";
print OUT "perl nonoverlap_exon_sort.pl exon_sort nonoverlap_exon_sort $chrfile\n";
print OUT "echo \"perl generate_gene_nonoverlap_exon.pl\"\n";
print OUT "perl generate_gene_nonoverlap_exon.pl\n";
print OUT "echo \"Parsing SAM files\"\n";
open(OUT2,">lane");
foreach $key(keys %sample)
{
  my $cnt = 1;
  my @files = @{$sample{$key}};
  push(@order,$key);
  my $i;
  for($i = 0; $i <= $#files; $i++)
  {
    my $file_name = $key."_".$i;
    print OUT2 "$file_name $key\n";
    $file_name = $file_name."_hit";
    print OUT "echo \"perl generate_map_summary.pl $files[$i] $chrfile $file_name\"\n";
    print OUT "perl generate_map_summary.pl $files[$i] $chrfile $file_name\n";
  }
}

open(OUT3,">sorted_file");

print OUT "rm -f junction\n";
for($i = 0; $i <= $#order; $i++)
{
  print $order[$i],"\n";
  my $sorted_file = $order[$i]."_st";
  print OUT3 $sorted_file,"\n";
  if($junction{$order[$i]})
  {
    my $file = "junction_".$i;
    print OUT "echo \"perl generate_map_junction_summary.pl $junction{$order[$i]} $file ",$i+1,"\"\n";
    print OUT "perl generate_map_junction_summary.pl $junction{$order[$i]} $file ",$i+1,"\n";
    print OUT "cat $file >> junction\n";
  }
}
close(OUT3);
print OUT "echo \"perl seqread.pl lane $chrfile\"\n";
print OUT "perl seqread.pl lane $chrfile\n";

foreach $key(keys %sample)
{
  my $sorted_file = $key."_st";
  print OUT "perl sort_seqread.pl $key $sorted_file $chrfile\n";
  print OUT "echo \"perl sort_seqread.pl $key $sorted_file $chrfile\"\n";
}

print OUT "echo \"perl nonoverlap_exon_read.pl nonoverlap_exon_sort junction nonoverlap_exon_read uniq_tt sorted_file\"\n";
print OUT "perl nonoverlap_exon_read.pl nonoverlap_exon_sort junction nonoverlap_exon_read uniq_tt sorted_file\n";
print OUT "echo \"perl data.pl nonoverlap_exon_sort gene_nonoverlap_exon nonoverlap_exon_read read exon_zb gene_zb\"\n";
print OUT "perl data.pl nonoverlap_exon_sort gene_nonoverlap_exon nonoverlap_exon_read read exon_zb gene_zb\n";

 
    
  
  
close(OUT2);
close(OUT);


    
 
  
